
import time,random,sys
from xaal.lib import Engine,Device,tools

eng = None

def usage():
    print("Usage:")
    print("  %s target_address" % sys.argv[0])

def wait():
    t0 = time.time()
    while time.time() < (t0+3):
        eng.loop()

def main():
    global eng
    target = tools.get_uuid(sys.argv[-1])
    if not target:
        usage()
        return

    dev = Device("switch.basic",tools.get_random_uuid())
    dev.vendor_id = "RAMBo"
    dev.product_id = "Fake Auto Switch"
    dev.info = 'Autobot switch for %s' % target

    eng = Engine()
    eng.add_device(dev)

    while 1:
        eng.send_request(dev,[target,],'turn_on')
        print('turn_on')
        wait()

        eng.send_request(dev,[target,],'turn_off')
        print('turn_off')
        wait()

        eng.send_request(dev,[target,],'set_brightness',{'brightness':random.randint(0,100)})
        print('set_brightness')
        wait()

if __name__ == '__main__':
    try:
        main()
    except KeyboardInterrupt:
        print("Bye ..")