from xaal.aiolib.network import NetworkConnector
import asyncio

from xaal.lib import MessageFactory,MessageParserError
from xaal.lib import config,helpers

import logging

logger = logging.getLogger('aiolib.test')

async def main():

    helpers.setup_console_logger()
    mf = MessageFactory(config.key)

    nc = NetworkConnector('224.0.29.200',1236,10)
    await nc.connect()
    while 1:
        data = await nc.get_data()
        if data:
            try:
                msg = mf.decode_msg(data)
                msg.dump()
            except MessageParserError as e:
                logger.warning(e)
                msg = None


asyncio.ensure_future(main())
asyncio.get_event_loop().run_forever()

