import asyncio
from logging import Logger
from xaal.aiolib.core import Engine
from xaal.lib import helpers,tools
from xaal.schemas import devices
import functools

import logging
logger = logging.getLogger(__name__)

helpers.setup_console_logger()



async def display(msg):
    if msg.source == tools.get_uuid('cee503ea-92ae-11e8-852a-408d5c18c800'):
        await asyncio.sleep(5)
        msg.dump()

async def toggle(dev):
    while 1:
        await asyncio.sleep(10)
        on_toggle(dev)

def on_toggle(dev):
    logger.warning('TOGGLE')
    dev.attributes['light'] = not dev.attributes['light']

eng = Engine()
eng.subscribe(display)

dev = devices.lamp_dimmer(tools.get_uuid('e4e08bd4-2774-11ec-85d2-d6bd5fe18736'))
dev.methods['toggle'] = functools.partial(on_toggle,dev)


eng.add_device(dev)
#asyncio.ensure_future(toggle(dev))

loop = asyncio.get_event_loop()
loop.create_task(toggle(dev))

try:
    
    eng.run()
except KeyboardInterrupt:
    pass

