from .core import Engine as CoreEngine
import functools
import asyncio

"""
The current xAAL Lib doesn't support asyncio. A full rewrite of Engine and NetworkConnector is needed.
The module provide an temporary hack to warps the Engine mainloop (run() function) in an asyncio loop.
Use this module as temporary fix only.
"""

def spawn(func):
    @functools.wraps(func)
    def spawn_future(*args,**kwargs):
        print(f"Calling {func.__name__}")
        asyncio.ensure_future(func(*args,**kwargs))
    return spawn_future

class Engine(CoreEngine):
    async def run(self):
        self.start()
        self.running = True
        while self.running:
            self.loop()
            await asyncio.sleep(0.02)

AsyncEngine = Engine
